Index: arch/mips32/loader/Makefile
===================================================================
--- arch/mips32/loader/Makefile	(revision 7431e8678eda2cc16350044bf2445c23684554eb)
+++ arch/mips32/loader/Makefile	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -48,10 +48,10 @@
 
 CFLAGS = -nostdinc -nostdlib -fno-builtin -Werror-implicit-function-declaration -Wmissing-prototypes -Werror -O3 -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mhard-float -mips3
-DEFS = 
+DEFS = -I.
 
 SOURCES = \
 	main.c \
 	msim.c \
-	printf.c \
+	../../../generic/printf.c \
 	asm.S \
 	boot.S
Index: arch/mips32/loader/main.c
===================================================================
--- arch/mips32/loader/main.c	(revision 7431e8678eda2cc16350044bf2445c23684554eb)
+++ arch/mips32/loader/main.c	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -28,5 +28,5 @@
 
 #include "main.h" 
-#include "printf.h"
+#include "../../../generic/printf.h"
 #include "msim.h"
 #include "asm.h"
Index: arch/mips32/loader/msim.c
===================================================================
--- arch/mips32/loader/msim.c	(revision 7431e8678eda2cc16350044bf2445c23684554eb)
+++ arch/mips32/loader/msim.c	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -28,9 +28,7 @@
  
 #include "msim.h"
-#include "printf.h"
-
+#include "../../../generic/printf.h"
 
 #define MSIM_VIDEORAM            0xB0000000
-
 
 void write(const char *str, const int len)
Index: arch/mips32/loader/msim.h
===================================================================
--- arch/mips32/loader/msim.h	(revision 7431e8678eda2cc16350044bf2445c23684554eb)
+++ arch/mips32/loader/msim.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -30,18 +30,7 @@
 #define __MSIM_H__
 
-#define NULL 0
-#define false 0
-#define true 1
-
-typedef __builtin_va_list va_list;
-
-#define va_start(ap, last) 		__builtin_va_start(ap, last)
-#define va_arg(ap, type) 		__builtin_va_arg(ap, type)
-#define va_end(ap)			__builtin_va_end(ap)
-
 extern void init(void);
 extern void halt(void);
 
-extern void write(const char *str, const int len);
 extern void *translate(void *addr);
 
Index: ch/mips32/loader/printf.c
===================================================================
--- arch/mips32/loader/printf.c	(revision 7431e8678eda2cc16350044bf2445c23684554eb)
+++ 	(revision )
@@ -1,241 +1,0 @@
-/*
- * Copyright (C) 2006 Martin Decky
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-#include "printf.h"
-#include "msim.h"
-
-static char digits[] = "0123456789abcdef";  /**< Hexadecimal characters */
-
-
-void puts(const char *str)
-{
-	int len = 0;
-	
-	while (str[len] != 0)
-		len++;
-	
-	write(str, len);
-}
-
-
-/** Print hexadecimal digits
- *
- * Print fixed count of hexadecimal digits from
- * the number num. The digits are printed in
- * natural left-to-right order starting with
- * the width-th digit.
- *
- * @param num   Number containing digits.
- * @param width Count of digits to print.
- *
- */
-static void print_fixed_hex(const __u64 num, const int width)
-{
-	int i;
-    
-	for (i = width * 8 - 4; i >= 0; i -= 4)
-	    write(digits + ((num >> i) & 0xf), 1);
-}
-
-
-/** Print number in given base
- *
- * Print significant digits of a number in given
- * base.
- *
- * @param num  Number to print.
- * @param base Base to print the number in (should
- *             be in range 2 .. 16).
- *
- */
-static void print_number(const __native num, const unsigned int base)
-{
-	int val = num;
-	char d[sizeof(__native) * 8 + 1];		/* this is good enough even for base == 2 */
-	int i = sizeof(__native) * 8 - 1;
-	
-	do {
-		d[i--] = digits[val % base];
-	} while (val /= base);
-	
-	d[sizeof(__native) * 8] = 0;	
-	puts(&d[i + 1]);
-}
-
-
-/** General formatted text print
- *
- * Print text formatted according the fmt parameter
- * and variant arguments. Each formatting directive
- * begins with \% (percentage) character and one of the
- * following character:
- *
- * \%    Prints the percentage character.
- *
- * s    The next variant argument is treated as char*
- *      and printed as a NULL terminated string.
- *
- * c    The next variant argument is treated as a single char.
- *
- * p    The next variant argument is treated as a maximum
- *      bit-width integer with respect to architecture
- *      and printed in full hexadecimal width.
- *
- * P    As with 'p', but '0x' is prefixed.
- *
- * q    The next variant argument is treated as a 64b integer
- *      and printed in full hexadecimal width.
- *
- * Q    As with 'q', but '0x' is prefixed.
- *
- * l    The next variant argument is treated as a 32b integer
- *      and printed in full hexadecimal width.
- *
- * L    As with 'l', but '0x' is prefixed.
- *
- * w    The next variant argument is treated as a 16b integer
- *      and printed in full hexadecimal width.
- *
- * W    As with 'w', but '0x' is prefixed.
- *
- * b    The next variant argument is treated as a 8b integer
- *      and printed in full hexadecimal width.
- *
- * B    As with 'b', but '0x' is prefixed.
- *
- * d    The next variant argument is treated as integer
- *      and printed in standard decimal format (only significant
- *      digits).
- *
- * x    The next variant argument is treated as integer
- *      and printed in standard hexadecimal format (only significant
- *      digits).
- *
- * X    As with 'x', but '0x' is prefixed.
- *
- * All other characters from fmt except the formatting directives
- * are printed in verbatim.
- *
- * @param fmt Formatting NULL terminated string.
- */
-void printf(const char *fmt, ...)
-{
-	int i = 0;
-	va_list ap;
-	char c;	
-	
-	va_start(ap, fmt);
-	
-	while ((c = fmt[i++])) {
-		switch (c) {
-			
-			/* control character */
-			case '%':
-				
-				switch (c = fmt[i++]) {
-					
-					/* percentile itself */
-					case '%':
-						break;
-					
-					/*
-					 * String and character conversions.
-					 */
-					case 's':
-						puts(va_arg(ap, char_ptr));
-						goto loop;
-					
-					case 'c':
-						c = (char) va_arg(ap, int);
-						break;
-					
-					/*
-					 * Hexadecimal conversions with fixed width.
-					 */
-					case 'P': 
-						puts("0x");
-					case 'p':
-						print_fixed_hex(va_arg(ap, __native), sizeof(__native));
-						goto loop;
-					
-					case 'Q':
-						puts("0x");
-					case 'q':
-						print_fixed_hex(va_arg(ap, __u64), INT64);
-						goto loop;
-					
-					case 'L': 
-						puts("0x");
-					case 'l':
-						print_fixed_hex(va_arg(ap, __native), INT32);
-						goto loop;
-					
-					case 'W':
-						puts("0x");
-					case 'w':
-						print_fixed_hex(va_arg(ap, __native), INT16);
-						goto loop;
-					
-					case 'B':
-						puts("0x");
-					case 'b':
-						print_fixed_hex(va_arg(ap, __native), INT8);
-						goto loop;
-					
-					/*
-					 * Decimal and hexadecimal conversions.
-					 */
-					case 'd':
-						print_number(va_arg(ap, __native), 10);
-						goto loop;
-					
-					case 'X':
-						puts("0x");
-					case 'x':
-						print_number(va_arg(ap, __native), 16);
-						goto loop;
-					
-					/*
-					 * Bad formatting.
-					 */
-					default:
-						goto out;
-			}
-			
-			default:
-				write(&c, 1);
-		}
-	
-loop:
-		;
-	}
-	
-out:
-	
-	va_end(ap);
-}
Index: ch/mips32/loader/printf.h
===================================================================
--- arch/mips32/loader/printf.h	(revision 7431e8678eda2cc16350044bf2445c23684554eb)
+++ 	(revision )
@@ -1,52 +1,0 @@
-/*
- * Copyright (C) 2006 Martin Decky
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifndef __PRINTF_H__
-#define __PRINTF_H__
-
-#define INT8	1
-#define INT16	2
-#define INT32	4
-#define INT64	8
-
-typedef signed char __s8;
-
-typedef unsigned char __u8;
-typedef unsigned short __u16;
-typedef unsigned int __u32;
-typedef unsigned long long __u64;
-
-typedef __u32 __address;
-typedef __u32 __native;
-
-typedef char *char_ptr;
-
-void puts(const char *str);
-void printf(const char *fmt, ...);
-
-#endif
Index: arch/mips32/loader/types.h
===================================================================
--- arch/mips32/loader/types.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
+++ arch/mips32/loader/types.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (C) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef TYPES_H__
+#define TYPES_H__
+
+#include "../../../generic/types.h"
+
+typedef signed char __s8;
+
+typedef unsigned char __u8;
+typedef unsigned short __u16;
+typedef unsigned int __u32;
+typedef unsigned long long __u64;
+
+typedef __u32 __address;
+typedef __u32 __native;
+
+#endif
Index: generic/printf.c
===================================================================
--- generic/printf.c	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
+++ generic/printf.c	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -0,0 +1,243 @@
+/*
+ * Copyright (C) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include "printf.h"
+#include "stdarg.h"
+#include <types.h>
+
+typedef char *char_ptr;
+
+static char digits[] = "0123456789abcdef";  /**< Hexadecimal characters */
+
+void puts(const char *str)
+{
+	int len = 0;
+	
+	while (str[len] != 0)
+		len++;
+	
+	write(str, len);
+}
+
+
+/** Print hexadecimal digits
+ *
+ * Print fixed count of hexadecimal digits from
+ * the number num. The digits are printed in
+ * natural left-to-right order starting with
+ * the width-th digit.
+ *
+ * @param num   Number containing digits.
+ * @param width Count of digits to print.
+ *
+ */
+static void print_fixed_hex(const __u64 num, const int width)
+{
+	int i;
+    
+	for (i = width * 8 - 4; i >= 0; i -= 4)
+	    write(digits + ((num >> i) & 0xf), 1);
+}
+
+
+/** Print number in given base
+ *
+ * Print significant digits of a number in given
+ * base.
+ *
+ * @param num  Number to print.
+ * @param base Base to print the number in (should
+ *             be in range 2 .. 16).
+ *
+ */
+static void print_number(const __native num, const unsigned int base)
+{
+	int val = num;
+	char d[sizeof(__native) * 8 + 1];		/* this is good enough even for base == 2 */
+	int i = sizeof(__native) * 8 - 1;
+	
+	do {
+		d[i--] = digits[val % base];
+	} while (val /= base);
+	
+	d[sizeof(__native) * 8] = 0;	
+	puts(&d[i + 1]);
+}
+
+
+/** General formatted text print
+ *
+ * Print text formatted according the fmt parameter
+ * and variant arguments. Each formatting directive
+ * begins with \% (percentage) character and one of the
+ * following character:
+ *
+ * \%    Prints the percentage character.
+ *
+ * s    The next variant argument is treated as char*
+ *      and printed as a NULL terminated string.
+ *
+ * c    The next variant argument is treated as a single char.
+ *
+ * p    The next variant argument is treated as a maximum
+ *      bit-width integer with respect to architecture
+ *      and printed in full hexadecimal width.
+ *
+ * P    As with 'p', but '0x' is prefixed.
+ *
+ * q    The next variant argument is treated as a 64b integer
+ *      and printed in full hexadecimal width.
+ *
+ * Q    As with 'q', but '0x' is prefixed.
+ *
+ * l    The next variant argument is treated as a 32b integer
+ *      and printed in full hexadecimal width.
+ *
+ * L    As with 'l', but '0x' is prefixed.
+ *
+ * w    The next variant argument is treated as a 16b integer
+ *      and printed in full hexadecimal width.
+ *
+ * W    As with 'w', but '0x' is prefixed.
+ *
+ * b    The next variant argument is treated as a 8b integer
+ *      and printed in full hexadecimal width.
+ *
+ * B    As with 'b', but '0x' is prefixed.
+ *
+ * d    The next variant argument is treated as integer
+ *      and printed in standard decimal format (only significant
+ *      digits).
+ *
+ * x    The next variant argument is treated as integer
+ *      and printed in standard hexadecimal format (only significant
+ *      digits).
+ *
+ * X    As with 'x', but '0x' is prefixed.
+ *
+ * All other characters from fmt except the formatting directives
+ * are printed in verbatim.
+ *
+ * @param fmt Formatting NULL terminated string.
+ */
+void printf(const char *fmt, ...)
+{
+	int i = 0;
+	va_list ap;
+	char c;	
+	
+	va_start(ap, fmt);
+	
+	while ((c = fmt[i++])) {
+		switch (c) {
+			
+			/* control character */
+			case '%':
+				
+				switch (c = fmt[i++]) {
+					
+					/* percentile itself */
+					case '%':
+						break;
+					
+					/*
+					 * String and character conversions.
+					 */
+					case 's':
+						puts(va_arg(ap, char_ptr));
+						goto loop;
+					
+					case 'c':
+						c = (char) va_arg(ap, int);
+						break;
+					
+					/*
+					 * Hexadecimal conversions with fixed width.
+					 */
+					case 'P': 
+						puts("0x");
+					case 'p':
+						print_fixed_hex(va_arg(ap, __native), sizeof(__native));
+						goto loop;
+					
+					case 'Q':
+						puts("0x");
+					case 'q':
+						print_fixed_hex(va_arg(ap, __u64), INT64);
+						goto loop;
+					
+					case 'L': 
+						puts("0x");
+					case 'l':
+						print_fixed_hex(va_arg(ap, __native), INT32);
+						goto loop;
+					
+					case 'W':
+						puts("0x");
+					case 'w':
+						print_fixed_hex(va_arg(ap, __native), INT16);
+						goto loop;
+					
+					case 'B':
+						puts("0x");
+					case 'b':
+						print_fixed_hex(va_arg(ap, __native), INT8);
+						goto loop;
+					
+					/*
+					 * Decimal and hexadecimal conversions.
+					 */
+					case 'd':
+						print_number(va_arg(ap, __native), 10);
+						goto loop;
+					
+					case 'X':
+						puts("0x");
+					case 'x':
+						print_number(va_arg(ap, __native), 16);
+						goto loop;
+					
+					/*
+					 * Bad formatting.
+					 */
+					default:
+						goto out;
+			}
+			
+			default:
+				write(&c, 1);
+		}
+	
+loop:
+		;
+	}
+	
+out:
+	
+	va_end(ap);
+}
Index: generic/printf.h
===================================================================
--- generic/printf.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
+++ generic/printf.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -0,0 +1,42 @@
+/*
+ * Copyright (C) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef PRINTF_H__
+#define PRINTF_H__
+
+#define INT8	1
+#define INT16	2
+#define INT32	4
+#define INT64	8
+
+extern void puts(const char *str);
+extern void printf(const char *fmt, ...);
+
+extern void write(const char *str, const int len);
+
+#endif
Index: generic/stdarg.h
===================================================================
--- generic/stdarg.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
+++ generic/stdarg.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -0,0 +1,38 @@
+/*
+ * Copyright (C) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef STDARG_H__
+#define STDARG_H__
+
+typedef __builtin_va_list va_list;
+
+#define va_start(ap, last)              __builtin_va_start(ap, last)
+#define va_arg(ap, type)                __builtin_va_arg(ap, type)
+#define va_end(ap)                      __builtin_va_end(ap)
+
+#endif
Index: generic/types.h
===================================================================
--- generic/types.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
+++ generic/types.h	(revision 282f4724a29a7f1525a6b730340cd7674af2e831)
@@ -0,0 +1,36 @@
+/*
+ * Copyright (C) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef GENERIC_TYPES_H__
+#define GENERIC_TYPES_H__
+
+#define NULL 0
+#define false 0
+#define true 1
+
+#endif